package nl.tudelft.ewi.es.mbdlistener.diagnoser;

import java.io.Serializable;


public abstract class Environment implements Comparable<Environment>, Serializable {
	private static final long serialVersionUID = 1L;

	@Override
	public int compareTo(Environment o) {
		if (this instanceof NodeEnvironment) {
			if (o instanceof NodeEnvironment) {
				NodeEnvironment node1 = (NodeEnvironment) this;
				NodeEnvironment node2 = (NodeEnvironment) o;
				
				return node1.getNodeID().compareTo(node2.getNodeID()); 
			}
			if (o instanceof LinkEnvironment) {
				return 1;
			}
			if (o instanceof SensorEnvironment) {
				return -1;
			}
		}
		if (this instanceof SensorEnvironment) {
			if (o instanceof SensorEnvironment) {
				SensorEnvironment node1 = (SensorEnvironment) this;
				SensorEnvironment node2 = (SensorEnvironment) o;
				
				return node1.getNodeID().compareTo(node2.getNodeID()); 
			}
			if (o instanceof LinkEnvironment) {
				return 1;
			}
			if (o instanceof NodeEnvironment) {
				return 1;
			}
		}
		else if (this instanceof LinkEnvironment) {
			if (o instanceof LinkEnvironment) {
				LinkEnvironment node1 = (LinkEnvironment) this;
				LinkEnvironment node2 = (LinkEnvironment) o;

				if (node1.getSender().compareTo(node2.getSender()) == 0) {
					return node1.getReceiver().compareTo(node2.getReceiver());
				}
				if (node1.getSender().compareTo(node2.getReceiver()) == 0){
					return node1.getReceiver().compareTo(node2.getSender());
				}
				return node1.getSender().compareTo(node2.getSender()); 
			}
			if (o instanceof NodeEnvironment) {
					return -1;
			}
			if (o instanceof SensorEnvironment) {
				return -1;
			}
		}
		throw new ClassCastException();
	}
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Environment)
			return this.compareTo((Environment) obj) == 0;
		return super.equals(obj);
	}
}
