package nl.tudelft.ewi.es.mbdlistener.graphics;

import java.util.Observable;

import nl.tudelft.ewi.es.mbdlistener.diagnoser.Diagnoser;
import nl.tudelft.ewi.es.mbdlistener.events.ConflictCancellationEvent;
import nl.tudelft.ewi.es.mbdlistener.events.ConflictEvent;
import nl.tudelft.ewi.es.mbdlistener.output.ListenerOutput;

public class GuiPrinter extends ListenerOutput {
	private final DiagnoserTreeModel treeModel;

	public GuiPrinter(Diagnoser diagnoser, DiagnoserTreeModel treeModel) {
		super(diagnoser);
		this.treeModel = treeModel;
	}

	@Override
	public void update(Observable o, Object arg) {
		super.update(o,arg);
		if (arg instanceof ConflictEvent) {
			treeModel.addConflict((ConflictEvent)arg, getDiagnoses());
		}
		if (arg instanceof ConflictCancellationEvent) {
			ConflictCancellationEvent cce = (ConflictCancellationEvent) arg;
			treeModel.addCancelConflict(cce, getDiagnoses());
		}
	}
}
