package nl.tudelft.ewi.es.mbdlistener.output;

import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Observable;

import nl.tudelft.ewi.es.mbdlistener.diagnoser.Diagnoser;
import nl.tudelft.ewi.es.mbdlistener.events.ConflictCancellationEvent;
import nl.tudelft.ewi.es.mbdlistener.events.ListenerEvent;

public class EventPrinter extends ListenerOutput {

	private final PrintStream outputStream;

	public EventPrinter(Diagnoser diagnoser, OutputStream os) {
		super(diagnoser);
		this.outputStream = new PrintStream(os, true);
	}

	@Override
	public void update(Observable o, Object arg) {
		super.update(o, arg);
		if (arg instanceof ConflictCancellationEvent) {
			if (getLastRemovedConflict() == null)
				outputStream.println(arg + " unknown conflict");
			else 
				outputStream.println(arg + ": " + getLastRemovedConflict());
		}
		else if (arg instanceof ListenerEvent) {
			outputStream.println(arg);
		}
	}
}
