package nl.tudelft.ewi.es.mbdlistener.output;

import java.util.List;
import java.util.Observable;
import java.util.Observer;

import nl.tudelft.ewi.es.mbdlistener.diagnoser.Conflict;
import nl.tudelft.ewi.es.mbdlistener.diagnoser.Diagnoser;
import nl.tudelft.ewi.es.mbdlistener.diagnoser.Diagnosis;
import nl.tudelft.ewi.es.mbdlistener.events.ConflictCancellationEvent;
import nl.tudelft.ewi.es.mbdlistener.events.ConflictEvent;

public abstract class ListenerOutput implements Observer {
	Diagnoser diagnoser;
	Conflict lastRemovedConflict = null;
	
	public ListenerOutput(Diagnoser diagnoser) {
		this.diagnoser = diagnoser;
	}
	
	protected List<Diagnosis> getDiagnoses() {
		return diagnoser.getDiagnoses();
	}
	
	protected Diagnosis getBestDiagnosis() {
		return diagnoser.getBestDiagnosis();
	}
	
	protected Conflict getLastRemovedConflict() {
		return lastRemovedConflict;
	}
	
	@Override
	public void update(Observable o, Object arg) {
		if (arg instanceof ConflictEvent) {
			ConflictEvent conflictEvent = (ConflictEvent) arg; 
			diagnoser.addConflict(conflictEvent.getConflict());
		}
		if (arg instanceof ConflictCancellationEvent) {
			ConflictCancellationEvent conflictCancellationEvent = (ConflictCancellationEvent) arg; 
			lastRemovedConflict = diagnoser.removeConflict(conflictCancellationEvent.getId(), conflictCancellationEvent.getSource());
		}
	}
}
