#!/usr/bin/env python
import sys

num_nodes = 49;

def loadNoiseGainTopo(filename):
    topo = dict()
    f = open(filename, "r")

    lines = f.readlines()
    noise = dict()
    for line in lines:
	s = line.split()
	if (len(s) > 0):
	    if (s[0] == "noise"):
		noise[s[1]] = float(s[2])
#		if float(s[3]) > -110.0:
#		    print " n" + s[1], "-- n" + s[2];
    f.close()
    f = open(filename, "r")
    
    gain = dict()
    lines = f.readlines()
    for line in lines:
	s = line.split()
	if (len(s) > 0):
	    if (s[0] == "gain"):
#		print s[1], noise[s[1]], s[3]
		if float(s[3]) > noise[s[1]]:
		    nodeId1 = int(s[1])
		    nodeId2 = int(s[2])
		    gainval = float(s[3])
		    
		    if not nodeId1 in gain:
			gain[nodeId1] = dict()
#		    print gain
		    gain[nodeId1][nodeId2] = gainval

#		    if s[1] in
#		    gain[int(s[1])] = float(s[3])
#		    print " n" + s[1], "-- n" + s[2], "[label=", float(s[3]) - noise[s[1]], " fontsize=30]"  ;

    processNode (48, gain[48], topo)

    for node1 in gain:
	processNode(node1, gain[node1], topo)

    if len(topo) < num_nodes:
	print "topo too small", len(topo)
    for node in topo:
	print "{",
	if len(topo[node]) == 1:
	    print topo[node][0], ",", "255",
	elif len(topo[node]) == 2:
	    print topo[node][0], ",", topo[node][1],
#	for node2 in topo[node]:
#	    print node2, ",",
	print "}, "
#	print node, topo[node]
	if len(topo[node]) == 0:
	    print "gain", gain[node]

def processNode(node1, gain, topo):
	if not node1 in topo:
	    topo[node1] = []

	from operator import itemgetter
	list = sorted(gain.items(), key=itemgetter(1), reverse=True)
#	node = 
#	print list
#	sys.exit(0)
	
	for node2,_ in list:
#	for node2 in gain[node1]:
	    if not node2 in topo:
		topo[node2] = []

	    if len(topo[node1]) < 2 and len(topo[node2]) < 2 and node1 not in topo[node2] and node2 not in topo[node1]:
		topo[node1] += [node2]
	        topo[node2] += [node1]
	    if len(topo[node1]) >= 2:
		break

def loadGainTopo(filename):
    f = open(filename, "r")

    lines = f.readlines()
    for line in lines:
	s = line.split()
	if (len(s) > 0):
	    if (s[0] == "gain"):
		if float(s[3]) > -110.0:
		    print " n" + s[1], "-- n" + s[2];

def loadTopo(filename):
    pass
#    f = open(filename, "r")
#
#    lines = f.readlines()
#    for line in lines:
#	s = line.split()
#	if (len(s) > 0):
#	    print "\tn" + s[0], " [ pos = \"" + s[1] + "," + s[2] + "!\"];";

def loadTestbedTopo(filename):
    f = open(filename, "r")
    nodes = open("nodes", "r")
    nodelist = nodes.readlines()
	
    lines = f.readlines()
    lines.pop(0)
    lines.pop(0)
    lines.pop(0)
    lines.pop(0)
    for line in lines:
	for nodeentry in nodelist:
	    if (nodeentry[0] == '#'):
		continue;
	    s = nodeentry.split(":")
	    line = line.replace(s[1], "n" +s[0])
	if line.startswith("}"):
	    break
	print line;



#def loadDiag(filename, diagno):
#    f = open(filename, "r")
#
#    lines = f.readlines()
#    for line in lines:
#	s = line.split("], [")
#	diag = s[diagno].strip("[]").split(", ")
#	for entry in diag:
#	    print "n" + entry.strip("Node "), "[style=filled,color=skyblue]";
#	if (len(s) > 0):
#		print "\tn" + s[0], " [ pos = \"" + s[1] + "," + s[2] + "!\"];";

if __name__ == '__main__':
    if len (sys.argv) != 2:
	diag = 0
    else:
	diag = int(sys.argv[1])
#    print "graph G {"
#    print "\tsize = \"10,10\""
#    print "overlap = false"
#    print "\tnode [shape=circle,height=1,fontsize=30]"
#    print "\tnode [shape=circle,height=1]"

    print "#define NOISY_DENSE"
    loadNoiseGainTopo("noisy_dense_linkgain.out")
    print "#endif"
    print "#define NOISY2"
    loadNoiseGainTopo("noisy2_linkgain.out")
    print "#endif"
    print "#define NOISY3"
    loadNoiseGainTopo("noisy3_linkgain.out")
    print "#endif"
    print "#define NOISY4"
    loadNoiseGainTopo("noisy4_linkgain.out")
    print "#endif"
    print "#define NOISY5"
    loadNoiseGainTopo("noisy5_linkgain.out")
    print "#endif"
    print "#define NOISY6"
    loadNoiseGainTopo("noisy6_linkgain.out")
    print "#endif"
    print "#define IDEALISED"
    loadNoiseGainTopo("idealised_linkgain.out")
    print "#endif"
#    loadDiag("diagnoses.txt", diag)

#    print "}"
