#ifndef ENVIRONMENT_H
#define ENVIRONMENT_H
#define ENV_TYPE "EnvironmentType"

typedef uint8_t environment_id_t;

enum {
	ENV_TYPE_NONE = unique(ENV_TYPE),
	ENV_TYPE_LINK = unique(ENV_TYPE),
	ENV_TYPE_NODE = unique(ENV_TYPE),
	ENV_TYPE_SENSOR = unique(ENV_TYPE),
	ENV_TYPE_COUNT = uniqueCount(ENV_TYPE)
};

typedef struct env_info {
	size_t params_size;
} env_info_t;

typedef nx_struct env_params_link {
    nx_am_addr_t sender;
    nx_am_addr_t receiver;
} env_params_link_t;

typedef nx_struct env_params_node {
    nx_am_addr_t node_id;
} env_params_node_t;

env_info_t const env_info[4] =
{
		{0},
		{sizeof(env_params_link_t)},
		{sizeof(env_params_node_t)},
		{sizeof(env_params_node_t)}
};

#endif
