# !/bin/bash

CLASSPATH=$CLASSPATH:/home/adriaan/svn/TestMBD/MbdListener/bin/
for DIR in `ls run* -d`; do
    if [ -d $DIR ]; then
    pushd "$DIR"
    echo "#!/usr/bin/gnuplot -persist" > ../$DIR.sh
    echo "set title '$DIR'" >>../$DIR.sh
    echo "set xrange [0:3600]" >> "../${DIR}.sh"
    echo "set yrange [-1:5]" >> "../${DIR}.sh"
    echo "set ylabel 'Number of nodes'" >> "../${DIR}.sh"
    echo "set xlabel 'Time(s)'" >> "../${DIR}.sh"
    echo "set x2label 'Nodes Missed'" >> "../${DIR}.sh"
    echo "set x2tics rotate" >> "../${DIR}.sh"
    echo "set y2range [-1:300]" >> "../${DIR}.sh"
    echo "set y2label 'Message count (cumulative)'" >> "../${DIR}.sh"
    echo "set y2tics" >> "../${DIR}.sh"
    
    chmod +x "../${DIR}.sh"

    for FILE in `ls *serial.out`; do
	echo "0 0 0 0 0" >  ../"$DIR.$FILE.plot"
	echo "0 0 0 0 0" >  ../"${DIR}.${FILE}_msg.plot"
	cat "$FILE" |listener -c confxml | java nl.tudelft.ewi.es.mbdlistener.MbdXmlListener >> ../"$DIR.$FILE.plot"
	cat "${FILE}" |listener -c confxml |msgcounter  >> ../"${DIR}.${FILE}_msg.plot"
	echo "10000 0 0 0 0" >>  ../"$DIR.$FILE.plot"
	echo "plot '$DIR.$FILE.plot' using 1:2 with steps lc rgb 'red' title '$FILE sensor false positives', '$DIR.$FILE.plot' using 1:2 with points lc rgb 'red' notitle"  >> "../${DIR}.sh"
	echo "replot '$DIR.$FILE.plot' u 1:3:x2ticlabels(10) with steps lc rgb 'blue' title '$FILE node false positives', '$DIR.$FILE.plot' u 1:3 with points lc rgb 'blue' notitle"  >> "../${DIR}.sh"
	echo "replot '$DIR.$FILE.plot' u 1:4 with steps lc rgb 'green' title '$FILE sensors missed', '$DIR.$FILE.plot' u 1:4 with points lc rgb 'green' notitle"  >> "../${DIR}.sh"
	echo "replot '$DIR.$FILE.plot' u 1:5 with steps lc rgb 'orange' title '$FILE nodes missed', '$DIR.$FILE.plot' u 1:5 with points lc rgb 'orange' notitle" >> "../${DIR}.sh"
	echo "replot '$DIR.$FILE.plot' u 1:4:6 with labels rotate left offset 0,0.5 lc rgb 'orange' notitle" >> "../${DIR}.sh"
	echo "replot '$DIR.$FILE.plot' u 1:5:7 with labels rotate left offset 0,0.5 lc rgb 'orange' notitle" >> "../${DIR}.sh"
	echo "replot '${DIR}.${FILE}_msg.plot' using 1:2 with l lc rgb 'grey' title '${FILE} message count' axes x1y2"   >> "../${DIR}.sh"

        echo "set size 1.8,1.8" >> "../${DIR}.sh"
        echo "set yrange [-0.5:2.5]" >> "../${DIR}.sh"

        echo "set terminal postscript eps" >> "../${DIR}.sh"
        echo "set output '$DIR.$FILE.eps'" >> "../${DIR}.sh"
        echo "replot" >> "../${DIR}.sh"

        echo "set terminal png" >> "../${DIR}.sh"
        echo "set output '$DIR.$FILE.png'" >> "../${DIR}.sh"
        echo "replot" >> "../${DIR}.sh"
	echo "Finished $FILE"
    done
    popd
    fi
done
